﻿CONST
    DAYS_TABLE = 7;
    COLOR_TASK = RGB(255, 200, 200);
    TASK_WIDTH = 125;


procedure Form1_OnShow (Sender: TObject; Action: string);
begin
    Form1.MonthCalendar.Date := now;
    DrawTimeTable(Form1.TableGrid1, Form1.MonthCalendar.Date, Form1.MonthCalendar.Date+DAYS_TABLE-1);
end;

procedure Form1_MonthCalendar_OnClick (Sender: TObject);
begin
    DrawTimeTable(Form1.TableGrid1, Form1.MonthCalendar.Date, Form1.MonthCalendar.Date+DAYS_TABLE-1);
end;



procedure Form1_TableGrid1_OnCellDoubleClick (Sender: TObject; ACol, ARow: Integer);
var
    id: integer;
begin
    id := Form1.TableGrid1.Cell[ACol, ARow].Tag;
    if id > 0 then // edit task
    begin
        frmAddTask.ShowRecord('timetable', id);
        DrawTimeTable(Form1.TableGrid1, Form1.MonthCalendar.Date, Form1.MonthCalendar.Date+DAYS_TABLE-1);
    end else
    begin // create new task
        Form1.bNewTask.Click;
    end;
end;




procedure Form1_bEditTask_OnClick (Sender: TObject; var Cancel: boolean);
var
    id: integer;
begin
    id := Form1.TableGrid1.Cell[Form1.TableGrid1.SelectedColumn, Form1.TableGrid1.SelectedRow].Tag;
    if id > 0 then
    begin
        frmAddTask.ShowRecord('timetable', id);
        DrawTimeTable(Form1.TableGrid1, Form1.MonthCalendar.Date, Form1.MonthCalendar.Date+DAYS_TABLE-1);
    end;
end;

procedure Form1_bDelete_OnClick (Sender: TObject; var Cancel: boolean);
var
    id: integer;
begin
    id := Form1.TableGrid1.Cell[Form1.TableGrid1.SelectedColumn, Form1.TableGrid1.SelectedRow].Tag;
    if id > 0 then
        if IDYES = MessageBox('Are you sure?', 'Confirmation', MB_YESNO+MB_ICONQUESTION) then
        begin
            SQLExecute('DELETE FROM timetable WHERE id='+IntToStr(id));
            DrawTimeTable(Form1.TableGrid1, Form1.MonthCalendar.Date, Form1.MonthCalendar.Date+DAYS_TABLE-1);
        end;
end;



procedure frmAddTask_OnShow (Sender: TObject; Action: string);
begin
    if Action = 'NewRecord' then
    begin
        if Form1.TableGrid1.SelectedColumn > 0 then
        begin
            frmAddTask.dtDate.DateTime := Form1.TableGrid1.Columns[ Form1.TableGrid1.SelectedColumn ].Tag;
            frmAddTask.dtTimeStart.DateTime := Form1.TableGrid1.SelectedRow * (30/1440);
            frmAddTask.dtTimeEnd.DateTime := frmAddTask.dtTimeStart.DateTime + (60/1440)
        end;
    end;
end;

procedure frmAddTask_bSaveTask_OnAfterClick (Sender: TObject);
begin
    DrawTimeTable(Form1.TableGrid1, Form1.MonthCalendar.Date, Form1.MonthCalendar.Date+6);
end;




procedure DrawTimeTable (TableGrid: TdbStringGridEx; dateFrom, dateTo: TDateTime);

    procedure MarkTask(idTask: integer; DateTask, StartTime, EndTime: TDateTime; TaskText: string = '');
    var
        iRow, qRow, iRowText: integer;
        iColDay: integer;
        RowTime: TDateTime;
    begin
        iColDay := Trunc(Trunc(DateTask) - Trunc(dateFrom))+1; // calculate number of column
        RowTime := 0.000000000000001;
        iRowText := 0;

        qRow := TableGrid.RowCount-1;
        for iRow := 0 to qRow do
        begin
            // mark task
            if (StartTime <= RowTime) and (EndTime >= RowTime) then
            begin
                TableGrid.Cell[iColDay, iRow].Color := COLOR_TASK;
                TableGrid.Cell[iColDay, iRow].Tag := idTask;
                Inc(iRowText);
                if iRowText = 1 then
                begin
                    TableGrid.Cells[iColDay, iRow] := FormatDateTime('t', StartTime) +' - '+ FormatDateTime('t', EndTime);
                    TableGrid.Cell[iColDay, iRow].FontStyle := fsBold;
                end;
                if iRowText = 2 then TableGrid.Cells[iColDay, iRow] := TaskText;
            end;

            RowTime := RowTime + (30/1440);
        end;
    end;


var
    iRow, iCol, qCols: integer;
    dt: TDateTime;
    sDay: string;
    Results: TDataSet;
begin
    TableGrid.BeginUpdate;
    TableGrid.Columns.Clear;

    // column for time
    try TableGrid.Columns.Add(TNxTextColumn); except end;
    TableGrid.Columns.LastAdded.Width := 50;
    //TableGrid.Columns.LastAdded.Header.Caption := '';
    TableGrid.Columns.LastAdded.Color := clWhite;


    // draw days for selected period
    dt := dateFrom;
    while dt <= dateTo do
    begin
        sDay := FormatDateTime('ddd  ddddd', dt);

        try
            TableGrid.Columns.Add(TNxTextColumn);
        except
        end;

        TableGrid.Columns.LastAdded.Width := TASK_WIDTH;
        TableGrid.Columns.LastAdded.Header.Caption := sDay;
        TableGrid.Columns.LastAdded.Tag := Trunc(dt); // store date of column
        TableGrid.Columns.LastAdded.Color := clWhite;

        dt := dt+1;
    end;


    // draw time 00:00-23:00
    for iRow := 0 to 47 do
    begin
        TableGrid.AddRow;
        if iRow mod 2 = 0 then TableGrid.Cells[0, iRow] := IntToStr(iRow div 2)+':00';
    end;




    // draw tasks
    SQLQuery('SELECT id, DateTask, TaskText, TimeStart, TimeEnd FROM timetable'+
    ' WHERE '+
    ' date("DateTask") BETWEEN date("'+FormatDateTime('yyyy-MM-DD',dateFrom)+'") and date("'+FormatDateTime('yyyy-MM-DD',dateTo)+'")', Results);


    while not Results.EOF do
    begin
        //ShowMessage(FloatToStr( SQLDateTimeToDateTime(Results.FieldByName('TimeStart').AsString) ));


        MarkTask(    Results.FieldByName('id').AsInteger,
                     SQLDateTimeToDateTime(Results.FieldByName('DateTask').AsString),
                     SQLDateTimeToDateTime(Results.FieldByName('TimeStart').AsString),
                     SQLDateTimeToDateTime(Results.FieldByName('TimeEnd').AsString),
                     Results.FieldByName('TaskText').AsString
                );

        Results.Next;
    end;

    TableGrid.EndUpdate;
end;





begin
    Form1.TableGrid1.Options := Form1.TableGrid1.Options - goSelectFullRow;
end.
